/* ***********************************************************
 * This file was automatically generated on 2019-09-17.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

/**
 * Measures air pressure and altitude changes
 */
public class BrickletBarometerV2 extends Device {
	public final static int DEVICE_IDENTIFIER = 2117;
	public final static String DEVICE_DISPLAY_NAME = "Barometer Bricklet 2.0";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "barometerv2", DEVICE_IDENTIFIER, BrickletBarometerV2.class);

	public final static byte FUNCTION_GET_AIR_PRESSURE = (byte)1;
	public final static byte FUNCTION_SET_AIR_PRESSURE_CALLBACK_CONFIGURATION = (byte)2;
	public final static byte FUNCTION_GET_AIR_PRESSURE_CALLBACK_CONFIGURATION = (byte)3;
	public final static byte FUNCTION_GET_ALTITUDE = (byte)5;
	public final static byte FUNCTION_SET_ALTITUDE_CALLBACK_CONFIGURATION = (byte)6;
	public final static byte FUNCTION_GET_ALTITUDE_CALLBACK_CONFIGURATION = (byte)7;
	public final static byte FUNCTION_GET_TEMPERATURE = (byte)9;
	public final static byte FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION = (byte)10;
	public final static byte FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION = (byte)11;
	public final static byte FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION = (byte)13;
	public final static byte FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION = (byte)14;
	public final static byte FUNCTION_SET_REFERENCE_AIR_PRESSURE = (byte)15;
	public final static byte FUNCTION_GET_REFERENCE_AIR_PRESSURE = (byte)16;
	public final static byte FUNCTION_SET_CALIBRATION = (byte)17;
	public final static byte FUNCTION_GET_CALIBRATION = (byte)18;
	public final static byte FUNCTION_SET_SENSOR_CONFIGURATION = (byte)19;
	public final static byte FUNCTION_GET_SENSOR_CONFIGURATION = (byte)20;
	public final static byte FUNCTION_GET_SPITFP_ERROR_COUNT = (byte)234;
	public final static byte FUNCTION_SET_BOOTLOADER_MODE = (byte)235;
	public final static byte FUNCTION_GET_BOOTLOADER_MODE = (byte)236;
	public final static byte FUNCTION_SET_WRITE_FIRMWARE_POINTER = (byte)237;
	public final static byte FUNCTION_WRITE_FIRMWARE = (byte)238;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)239;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)240;
	public final static byte FUNCTION_GET_CHIP_TEMPERATURE = (byte)242;
	public final static byte FUNCTION_RESET = (byte)243;
	public final static byte FUNCTION_WRITE_UID = (byte)248;
	public final static byte FUNCTION_READ_UID = (byte)249;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_AIR_PRESSURE = 4;
	private final static int CALLBACK_ALTITUDE = 8;
	private final static int CALLBACK_TEMPERATURE = 12;

	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int DATA_RATE_OFF = 0;
	public final static int DATA_RATE_1HZ = 1;
	public final static int DATA_RATE_10HZ = 2;
	public final static int DATA_RATE_25HZ = 3;
	public final static int DATA_RATE_50HZ = 4;
	public final static int DATA_RATE_75HZ = 5;
	public final static int LOW_PASS_FILTER_OFF = 0;
	public final static int LOW_PASS_FILTER_1_9TH = 1;
	public final static int LOW_PASS_FILTER_1_20TH = 2;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;

	private List<AirPressureListener> listenerAirPressure = new CopyOnWriteArrayList<AirPressureListener>();
	private List<AltitudeListener> listenerAltitude = new CopyOnWriteArrayList<AltitudeListener>();
	private List<TemperatureListener> listenerTemperature = new CopyOnWriteArrayList<TemperatureListener>();

	public class AirPressureCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class AltitudeCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class TemperatureCallbackConfiguration {
		public long period;
		public boolean valueHasToChange;
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "period = " + period + ", " + "valueHasToChange = " + valueHasToChange + ", " + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class MovingAverageConfiguration {
		public int movingAverageLengthAirPressure;
		public int movingAverageLengthTemperature;

		public String toString() {
			return "[" + "movingAverageLengthAirPressure = " + movingAverageLengthAirPressure + ", " + "movingAverageLengthTemperature = " + movingAverageLengthTemperature + "]";
		}
	}

	public class Calibration {
		public int measuredAirPressure;
		public int actualAirPressure;

		public String toString() {
			return "[" + "measuredAirPressure = " + measuredAirPressure + ", " + "actualAirPressure = " + actualAirPressure + "]";
		}
	}

	public class SensorConfiguration {
		public int dataRate;
		public int airPressureLowPassFilter;

		public String toString() {
			return "[" + "dataRate = " + dataRate + ", " + "airPressureLowPassFilter = " + airPressureLowPassFilter + "]";
		}
	}

	public class SPITFPErrorCount {
		public long errorCountAckChecksum;
		public long errorCountMessageChecksum;
		public long errorCountFrame;
		public long errorCountOverflow;

		public String toString() {
			return "[" + "errorCountAckChecksum = " + errorCountAckChecksum + ", " + "errorCountMessageChecksum = " + errorCountMessageChecksum + ", " + "errorCountFrame = " + errorCountFrame + ", " + "errorCountOverflow = " + errorCountOverflow + "]";
		}
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletBarometerV2#setAirPressureCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletBarometerV2#getAirPressure()}.
	 */
	public interface AirPressureListener extends DeviceListener {
		public void airPressure(int airPressure);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletBarometerV2#setAltitudeCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletBarometerV2#getAltitude()}.
	 */
	public interface AltitudeListener extends DeviceListener {
		public void altitude(int altitude);
	}

	/**
	 * This listener is triggered periodically according to the configuration set by
	 * {@link BrickletBarometerV2#setTemperatureCallbackConfiguration(long, boolean, char, int, int)}.
	 * 
	 * The parameter is the same as {@link BrickletBarometerV2#getTemperature()}.
	 */
	public interface TemperatureListener extends DeviceListener {
		public void temperature(int temperature);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletBarometerV2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_AIR_PRESSURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_AIR_PRESSURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_AIR_PRESSURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ALTITUDE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_ALTITUDE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_ALTITUDE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_REFERENCE_AIR_PRESSURE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_REFERENCE_AIR_PRESSURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CALIBRATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CALIBRATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SENSOR_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SENSOR_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_SPITFP_ERROR_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_BOOTLOADER_MODE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_WRITE_FIRMWARE_POINTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_FIRMWARE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CHIP_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_RESET)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_UID)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_READ_UID)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_AIR_PRESSURE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int airPressure = (bb.getInt());

				for (AirPressureListener listener: listenerAirPressure) {
					listener.airPressure(airPressure);
				}
			}
		};

		callbacks[CALLBACK_ALTITUDE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int altitude = (bb.getInt());

				for (AltitudeListener listener: listenerAltitude) {
					listener.altitude(altitude);
				}
			}
		};

		callbacks[CALLBACK_TEMPERATURE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int temperature = (bb.getInt());

				for (TemperatureListener listener: listenerTemperature) {
					listener.temperature(temperature);
				}
			}
		};
	}

	/**
	 * Returns the measured air pressure. The value has a range of
	 * 260000 to 1260000 and is given in mbar/1000, i.e. a value of
	 * 1001092 means that an air pressure of 1001.092 mbar is measured.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletBarometerV2.AirPressureListener} listener. You can set the listener configuration
	 * with {@link BrickletBarometerV2#setAirPressureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getAirPressure() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AIR_PRESSURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int airPressure = (bb.getInt());

		return airPressure;
	}

	/**
	 * The period in ms is the period with which the {@link BrickletBarometerV2.AirPressureListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletBarometerV2.AirPressureListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 * 
	 * The default value is (0, false, 'x', 0, 0).
	 */
	public void setAirPressureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)22, FUNCTION_SET_AIR_PRESSURE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletBarometerV2#setAirPressureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public AirPressureCallbackConfiguration getAirPressureCallbackConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AIR_PRESSURE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AirPressureCallbackConfiguration obj = new AirPressureCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Returns the relative altitude of the air pressure sensor. The value
	 * is given in mm and is calculated based on the difference between the
	 * current air pressure and the reference air pressure that can be set
	 * with {@link BrickletBarometerV2#setReferenceAirPressure(int)}.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletBarometerV2.AltitudeListener} listener. You can set the listener configuration
	 * with {@link BrickletBarometerV2#setAltitudeCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getAltitude() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALTITUDE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int altitude = (bb.getInt());

		return altitude;
	}

	/**
	 * The period in ms is the period with which the {@link BrickletBarometerV2.AltitudeListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletBarometerV2.AltitudeListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 * 
	 * The default value is (0, false, 'x', 0, 0).
	 */
	public void setAltitudeCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)22, FUNCTION_SET_ALTITUDE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletBarometerV2#setAltitudeCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public AltitudeCallbackConfiguration getAltitudeCallbackConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ALTITUDE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AltitudeCallbackConfiguration obj = new AltitudeCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Returns the temperature of the air pressure sensor. The value
	 * has a range of -4000 to 8500 and is given in °C/100, i.e. a value
	 * of 2007 means that a temperature of 20.07 °C is measured.
	 * 
	 * This temperature is used internally for temperature compensation
	 * of the air pressure measurement. It is not as accurate as the
	 * temperature measured by the :ref:`temperature_v2_bricklet` or the
	 * :ref:`temperature_ir_v2_bricklet`.
	 * 
	 * 
	 * If you want to get the value periodically, it is recommended to use the
	 * {@link BrickletBarometerV2.TemperatureListener} listener. You can set the listener configuration
	 * with {@link BrickletBarometerV2#setTemperatureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public int getTemperature() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getInt());

		return temperature;
	}

	/**
	 * The period in ms is the period with which the {@link BrickletBarometerV2.TemperatureListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * If the `value has to change`-parameter is set to true, the listener is only
	 * triggered after the value has changed. If the value didn't change
	 * within the period, the listener is triggered immediately on change.
	 * 
	 * If it is set to false, the listener is continuously triggered with the period,
	 * independent of the value.
	 * 
	 * It is furthermore possible to constrain the listener with thresholds.
	 * 
	 * The `option`-parameter together with min/max sets a threshold for the {@link BrickletBarometerV2.TemperatureListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Threshold is turned off"
	 *  "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
	 *  "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
	 *  "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * If the option is set to 'x' (threshold turned off) the listener is triggered with the fixed period.
	 * 
	 * The default value is (0, false, 'x', 0, 0).
	 */
	public void setTemperatureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)22, FUNCTION_SET_TEMPERATURE_CALLBACK_CONFIGURATION, this);

		bb.putInt((int)period);
		bb.put((byte)(valueHasToChange ? 1 : 0));
		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletBarometerV2#setTemperatureCallbackConfiguration(long, boolean, char, int, int)}.
	 */
	public TemperatureCallbackConfiguration getTemperatureCallbackConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_TEMPERATURE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		TemperatureCallbackConfiguration obj = new TemperatureCallbackConfiguration();
		obj.period = IPConnection.unsignedInt(bb.getInt());
		obj.valueHasToChange = (bb.get()) != 0;
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the length of a `moving averaging &lt;https://en.wikipedia.org/wiki/Moving_average&gt;`__
	 * for the air pressure and temperature measurements.
	 * 
	 * Setting the length to 1 will turn the averaging off. With less
	 * averaging, there is more noise on the data.
	 * 
	 * The range for the averaging is 1-1000.
	 * 
	 * If you want to do long term measurements the longest moving average will give
	 * the cleanest results.
	 * 
	 * The default value is 100.
	 */
	public void setMovingAverageConfiguration(int movingAverageLengthAirPressure, int movingAverageLengthTemperature) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION, this);

		bb.putShort((short)movingAverageLengthAirPressure);
		bb.putShort((short)movingAverageLengthTemperature);

		sendRequest(bb.array());
	}

	/**
	 * Returns the moving average configuration as set by
	 * {@link BrickletBarometerV2#setMovingAverageConfiguration(int, int)}.
	 */
	public MovingAverageConfiguration getMovingAverageConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		MovingAverageConfiguration obj = new MovingAverageConfiguration();
		obj.movingAverageLengthAirPressure = IPConnection.unsignedShort(bb.getShort());
		obj.movingAverageLengthTemperature = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Sets the reference air pressure in mbar/1000 for the altitude calculation.
	 * Valid values are between 260000 and 1260000. Setting the reference to the
	 * current air pressure results in a calculated altitude of 0mm. Passing 0 is
	 * a shortcut for passing the current air pressure as reference.
	 * 
	 * Well known reference values are the Q codes
	 * `QNH &lt;https://en.wikipedia.org/wiki/QNH&gt;`__ and
	 * `QFE &lt;https://en.wikipedia.org/wiki/Mean_sea_level_pressure#Mean_sea_level_pressure&gt;`__
	 * used in aviation.
	 * 
	 * The default value is 1013.25mbar.
	 */
	public void setReferenceAirPressure(int airPressure) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_REFERENCE_AIR_PRESSURE, this);

		bb.putInt(airPressure);

		sendRequest(bb.array());
	}

	/**
	 * Returns the reference air pressure as set by {@link BrickletBarometerV2#setReferenceAirPressure(int)}.
	 */
	public int getReferenceAirPressure() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_REFERENCE_AIR_PRESSURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int airPressure = (bb.getInt());

		return airPressure;
	}

	/**
	 * Sets the one point calibration (OPC) values for the air pressure measurement.
	 * 
	 * Before the Bricklet can be calibrated any previous calibration has to be removed
	 * by setting ``measured air pressure`` and ``actual air pressure`` to 0.
	 * 
	 * Then the current air pressure has to be measured using the Bricklet
	 * (``measured air pressure``) and with and accurate reference barometer
	 * (``actual air pressure``) at the same time and passed to this function in
	 * mbar/1000.
	 * 
	 * After proper calibration the air pressure measurement can achieve an accuracy
	 * up to 0.2 mbar.
	 * 
	 * The calibration is saved in the EEPROM of the Bricklet and only needs to be
	 * configured once.
	 */
	public void setCalibration(int measuredAirPressure, int actualAirPressure) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)16, FUNCTION_SET_CALIBRATION, this);

		bb.putInt(measuredAirPressure);
		bb.putInt(actualAirPressure);

		sendRequest(bb.array());
	}

	/**
	 * Returns the air pressure one point calibration values as set by
	 * {@link BrickletBarometerV2#setCalibration(int, int)}.
	 */
	public Calibration getCalibration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CALIBRATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Calibration obj = new Calibration();
		obj.measuredAirPressure = (bb.getInt());
		obj.actualAirPressure = (bb.getInt());

		return obj;
	}

	/**
	 * Configures the data rate and air pressure low pass filter. The low pass filter
	 * cut-off frequency (if enabled) can be set to 1/9th or 1/20th of the configure
	 * data rate to decrease the noise on the air pressure data.
	 * 
	 * The low pass filter configuration only applies to the air pressure measurement.
	 * There is no low pass filter for the temperature measurement.
	 * 
	 * A higher data rate will result in a less precise temperature because of
	 * self-heating of the sensor. If the accuracy of the temperature reading is
	 * important to you, we would recommend the 1Hz data rate.
	 * 
	 * The default values are 50Hz data rate and 1/9th low pass filter.
	 */
	public void setSensorConfiguration(int dataRate, int airPressureLowPassFilter) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_SENSOR_CONFIGURATION, this);

		bb.put((byte)dataRate);
		bb.put((byte)airPressureLowPassFilter);

		sendRequest(bb.array());
	}

	/**
	 * Returns the sensor configuration as set by {@link BrickletBarometerV2#setSensorConfiguration(int, int)}.
	 */
	public SensorConfiguration getSensorConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SENSOR_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SensorConfiguration obj = new SensorConfiguration();
		obj.dataRate = IPConnection.unsignedByte(bb.get());
		obj.airPressureLowPassFilter = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the error count for the communication between Brick and Bricklet.
	 * 
	 * The errors are divided into
	 * 
	 * * ACK checksum errors,
	 * * message checksum errors,
	 * * framing errors and
	 * * overflow errors.
	 * 
	 * The errors counts are for errors that occur on the Bricklet side. All
	 * Bricks have a similar function that returns the errors on the Brick side.
	 */
	public SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_SPITFP_ERROR_COUNT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		SPITFPErrorCount obj = new SPITFPErrorCount();
		obj.errorCountAckChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountMessageChecksum = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountFrame = IPConnection.unsignedInt(bb.getInt());
		obj.errorCountOverflow = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the bootloader mode and returns the status after the requested
	 * mode change was instigated.
	 * 
	 * You can change from bootloader mode to firmware mode and vice versa. A change
	 * from bootloader mode to firmware mode will only take place if the entry function,
	 * device identifier and CRC are present and correct.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int setBootloaderMode(int mode) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_BOOTLOADER_MODE, this);

		bb.put((byte)mode);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Returns the current bootloader mode, see {@link BrickletBarometerV2#setBootloaderMode(int)}.
	 */
	public int getBootloaderMode() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_BOOTLOADER_MODE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int mode = IPConnection.unsignedByte(bb.get());

		return mode;
	}

	/**
	 * Sets the firmware pointer for {@link BrickletBarometerV2#writeFirmware(int[])}. The pointer has
	 * to be increased by chunks of size 64. The data is written to flash
	 * every 4 chunks (which equals to one page of size 256).
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_WRITE_FIRMWARE_POINTER, this);

		bb.putInt((int)pointer);

		sendRequest(bb.array());
	}

	/**
	 * Writes 64 Bytes of firmware at the position as written by
	 * {@link BrickletBarometerV2#setWriteFirmwarePointer(long)} before. The firmware is written
	 * to flash every 4 chunks.
	 * 
	 * You can only write firmware in bootloader mode.
	 * 
	 * This function is used by Brick Viewer during flashing. It should not be
	 * necessary to call it in a normal user program.
	 */
	public int writeFirmware(int[] data) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)72, FUNCTION_WRITE_FIRMWARE, this);

		for (int i = 0; i < 64; i++) {
			bb.put((byte)data[i]);
		}

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int status = IPConnection.unsignedByte(bb.get());

		return status;
	}

	/**
	 * Sets the status LED configuration. By default the LED shows
	 * communication traffic between Brick and Bricklet, it flickers once
	 * for every 10 received data packets.
	 * 
	 * You can also turn the LED permanently on/off or show a heartbeat.
	 * 
	 * If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
	 */
	public void setStatusLEDConfig(int config) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletBarometerV2#setStatusLEDConfig(int)}
	 */
	public int getStatusLEDConfig() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the temperature in °C as measured inside the microcontroller. The
	 * value returned is not the ambient temperature!
	 * 
	 * The temperature is only proportional to the real temperature and it has bad
	 * accuracy. Practically it is only useful as an indicator for
	 * temperature changes.
	 */
	public int getChipTemperature() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CHIP_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Calling this function will reset the Bricklet. All configurations
	 * will be lost.
	 * 
	 * After a reset you have to create new device objects,
	 * calling functions on the existing ones will result in
	 * undefined behavior!
	 */
	public void reset() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_RESET, this);


		sendRequest(bb.array());
	}

	/**
	 * Writes a new UID into flash. If you want to set a new UID
	 * you have to decode the Base58 encoded UID string into an
	 * integer first.
	 * 
	 * We recommend that you use Brick Viewer to change the UID.
	 */
	public void writeUID(long uid) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_WRITE_UID, this);

		bb.putInt((int)uid);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current UID as an integer. Encode as
	 * Base58 to get the usual string version.
	 */
	public long readUID() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_UID, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long uid = IPConnection.unsignedInt(bb.getInt());

		return uid;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a AirPressure listener.
	 */
	public void addAirPressureListener(AirPressureListener listener) {
		listenerAirPressure.add(listener);
	}

	/**
	 * Removes a AirPressure listener.
	 */
	public void removeAirPressureListener(AirPressureListener listener) {
		listenerAirPressure.remove(listener);
	}

	/**
	 * Adds a Altitude listener.
	 */
	public void addAltitudeListener(AltitudeListener listener) {
		listenerAltitude.add(listener);
	}

	/**
	 * Removes a Altitude listener.
	 */
	public void removeAltitudeListener(AltitudeListener listener) {
		listenerAltitude.remove(listener);
	}

	/**
	 * Adds a Temperature listener.
	 */
	public void addTemperatureListener(TemperatureListener listener) {
		listenerTemperature.add(listener);
	}

	/**
	 * Removes a Temperature listener.
	 */
	public void removeTemperatureListener(TemperatureListener listener) {
		listenerTemperature.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletBarometerV2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletBarometerV2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletBarometerV2Config cfg = (BrickletBarometerV2Config) config.as(BrickletBarometerV2Config.class);
        this.addAirPressureListener((airPressure) -> {if(true) {updateStateFn.accept("BarometerV2AirPressure", transformBarometerV2AirPressureCallback0(airPressure, cfg));}});
		this.addAltitudeListener((altitude) -> {if(true) {updateStateFn.accept("BarometerV2Altitude", transformBarometerV2AltitudeCallback0(altitude, cfg));}});
		this.addTemperatureListener((temperature) -> {if(true) {updateStateFn.accept("BarometerV2Temperature", transformBarometerV2TemperatureCallback0(temperature, cfg));}});
        this.setReferenceAirPressure(cfg.referenceAirPressure.multiply(new BigDecimal(1000)).intValue());
		this.setMovingAverageConfiguration(cfg.airPressureMovingAverageLength, cfg.temperatureMovingAverageLength);
		this.setSensorConfiguration(cfg.dataRate, cfg.airPressureLowPassFilter);
		{
		BrickletBarometerV2AirPressureConfig channelCfg = getChannelConfigFn.apply("BarometerV2AirPressure").as(BrickletBarometerV2AirPressureConfig.class);
		this.setAirPressureCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletBarometerV2AltitudeConfig channelCfg = getChannelConfigFn.apply("BarometerV2Altitude").as(BrickletBarometerV2AltitudeConfig.class);
		this.setAltitudeCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletBarometerV2TemperatureConfig channelCfg = getChannelConfigFn.apply("BarometerV2Temperature").as(BrickletBarometerV2TemperatureConfig.class);
		this.setTemperatureCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletBarometerV2Config cfg = (BrickletBarometerV2Config) config.as(BrickletBarometerV2Config.class);
        this.listenerAirPressure.clear();
		this.listenerAltitude.clear();
		this.listenerTemperature.clear();
        this.setAirPressureCallbackConfiguration(0, true, 'x', 0, 0);
		this.setAltitudeCallbackConfiguration(0, true, 'x', 0, 0);
		this.setTemperatureCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletBarometerV2Config cfg = (BrickletBarometerV2Config) config.as(BrickletBarometerV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BarometerV2AirPressure");
		result.add("BarometerV2Altitude");
		result.add("BarometerV2Temperature");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BarometerV2AirPressure":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BarometerV2AirPressure"), "Air Pressure", "Number:Pressure").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BarometerV2AirPressure")).withDescription("Measured air pressure")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(260)).withMaximum(BigDecimal.valueOf(1260)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BarometerV2Altitude":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BarometerV2Altitude"), "Altitude", "Number:Length").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BarometerV2Altitude")).withDescription("Relative Altitude derived from air pressure")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BarometerV2Temperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BarometerV2Temperature"), "Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BarometerV2Temperature")).withDescription("Measured temperature")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-40)).withMaximum(BigDecimal.valueOf(85)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Barometer Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures air pressure and altitude changes").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BarometerV2AirPressure", new ChannelTypeUID("tinkerforge", "BarometerV2AirPressure")).build(), new ChannelDefinitionBuilder("BarometerV2Altitude", new ChannelTypeUID("tinkerforge", "BarometerV2Altitude")).build(), new ChannelDefinitionBuilder("BarometerV2Temperature", new ChannelTypeUID("tinkerforge", "BarometerV2Temperature")).build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:barometerv2":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("airPressureMovingAverageLength", Type.INTEGER).withDefault("100").withGroupName("average").withLabel("Air Pressure Moving Average Length").withMinimum(BigDecimal.valueOf(1)).withMaximum(BigDecimal.valueOf(1000)).build(), ConfigDescriptionParameterBuilder.create("temperatureMovingAverageLength", Type.INTEGER).withDefault("100").withGroupName("average").withLabel("Temperature Moving Average Length").withMinimum(BigDecimal.valueOf(1)).withMaximum(BigDecimal.valueOf(1000)).build(), ConfigDescriptionParameterBuilder.create("referenceAirPressure", Type.DECIMAL).withDefault("1013.25").withDescription("The reference air pressure in mbar for the altitude calculation. Valid values are between 260 and 1260. Setting the reference to the current air pressure results in a calculated altitude of 0 m.").withLabel("Reference Air Pressure").withMinimum(BigDecimal.valueOf(260)).withMaximum(BigDecimal.valueOf(1260)).build(), ConfigDescriptionParameterBuilder.create("dataRate", Type.INTEGER).withDefault("4").withDescription("Configures the data rate. A higher data rate will result in a less precise temperature because of self-heating of the sensor. If the accuracy of the temperature reading is important to you, we would recommend the 1Hz data rate.").withLabel("Data Rate").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "1Hz"), new ParameterOption("2", "10Hz"), new ParameterOption("3", "25Hz"), new ParameterOption("4", "50Hz"), new ParameterOption("5", "75Hz"))).build(), ConfigDescriptionParameterBuilder.create("airPressureLowPassFilter", Type.INTEGER).withDefault("1").withDescription("Configures the air pressure low pass filter. The low pass filter cut-off frequency (if enabled) can be set to 1/9th or 1/20th of the configure data rate to decrease the noise on the air pressure data.").withLabel("Air Pressure Low Pass Filter").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "1/9th"), new ParameterOption("2", "1/20th"))).build()), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"), new ConfigDescriptionParameterGroup("average", "null", true, "Averaging", "Sets the length of a moving averaging for the air pressure and temperature.<br/><br/>Setting the length to 1 will turn the averaging off. With less averaging, there is more noise on the data.<br/><br/>The range for the averaging is 1-1000.<br/><br/>If you want to do long term measurements the longest moving average will give the cleanest results.<br/><br/>The default value is 100.")));
            case "channel-type:tinkerforge:BarometerV2AirPressure":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:BarometerV2Altitude":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:BarometerV2Temperature":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletBarometerV2Config cfg = (BrickletBarometerV2Config) config.as(BrickletBarometerV2Config.class);
        switch(value) {
            case "BarometerV2AirPressure": {
                   BrickletBarometerV2AirPressureConfig channelCfg = channelConfig.as(BrickletBarometerV2AirPressureConfig.class);
                   updateStateFn.accept(value, transformBarometerV2AirPressureGetter0(this.getAirPressure(), cfg));
                   return;
               }
            case "BarometerV2Altitude": {
                   BrickletBarometerV2AltitudeConfig channelCfg = channelConfig.as(BrickletBarometerV2AltitudeConfig.class);
                   updateStateFn.accept(value, transformBarometerV2AltitudeGetter0(this.getAltitude(), cfg));
                   return;
               }
            case "BarometerV2Temperature": {
                   BrickletBarometerV2TemperatureConfig channelCfg = channelConfig.as(BrickletBarometerV2TemperatureConfig.class);
                   updateStateFn.accept(value, transformBarometerV2TemperatureGetter0(this.getTemperature(), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletBarometerV2Config cfg = (BrickletBarometerV2Config) config.as(BrickletBarometerV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBarometerV2AirPressureCallback0(int airPressure, BrickletBarometerV2Config cfg) {
        return new QuantityType<>(airPressure / 1000.0, SmartHomeUnits.MILLIBAR);
    }
	    private org.eclipse.smarthome.core.types.State transformBarometerV2AltitudeCallback0(int altitude, BrickletBarometerV2Config cfg) {
        return new QuantityType<>(altitude / 1000.0, SIUnits.METRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBarometerV2TemperatureCallback0(int temperature, BrickletBarometerV2Config cfg) {
        return new QuantityType<>(temperature / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBarometerV2AirPressureGetter0(int value, BrickletBarometerV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.MILLIBAR);
    }
	    private org.eclipse.smarthome.core.types.State transformBarometerV2AltitudeGetter0(int value, BrickletBarometerV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SIUnits.METRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBarometerV2TemperatureGetter0(int value, BrickletBarometerV2Config cfg) {
        return new QuantityType<>(value / 100.0, SIUnits.CELSIUS);
    }
}
