/* ***********************************************************
 * This file was automatically generated on 2019-09-17.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

/**
 * Passive infrared (PIR) motion sensor with 7m range
 */
public class BrickletMotionDetector extends Device {
	public final static int DEVICE_IDENTIFIER = 233;
	public final static String DEVICE_DISPLAY_NAME = "Motion Detector Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "motiondetector", DEVICE_IDENTIFIER, BrickletMotionDetector.class);

	public final static byte FUNCTION_GET_MOTION_DETECTED = (byte)1;
	public final static byte FUNCTION_SET_STATUS_LED_CONFIG = (byte)4;
	public final static byte FUNCTION_GET_STATUS_LED_CONFIG = (byte)5;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_MOTION_DETECTED = 2;
	private final static int CALLBACK_DETECTION_CYCLE_ENDED = 3;

	public final static short MOTION_NOT_DETECTED = (short)0;
	public final static short MOTION_DETECTED = (short)1;
	public final static short STATUS_LED_CONFIG_OFF = (short)0;
	public final static short STATUS_LED_CONFIG_ON = (short)1;
	public final static short STATUS_LED_CONFIG_SHOW_STATUS = (short)2;

	private List<MotionDetectedListener> listenerMotionDetected = new CopyOnWriteArrayList<MotionDetectedListener>();
	private List<DetectionCycleEndedListener> listenerDetectionCycleEnded = new CopyOnWriteArrayList<DetectionCycleEndedListener>();

	/**
	 * This listener is called after a motion was detected.
	 */
	public interface MotionDetectedListener extends DeviceListener {
		public void motionDetected();
	}

	/**
	 * This listener is called when the detection cycle ended. When this
	 * listener is called, a new motion can be detected again after approximately 2
	 * seconds.
	 */
	public interface DetectionCycleEndedListener extends DeviceListener {
		public void detectionCycleEnded();
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletMotionDetector(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 1;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MOTION_DETECTED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_STATUS_LED_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_MOTION_DETECTED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				for (MotionDetectedListener listener: listenerMotionDetected) {
					listener.motionDetected();
				}
			}
		};

		callbacks[CALLBACK_DETECTION_CYCLE_ENDED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				for (DetectionCycleEndedListener listener: listenerDetectionCycleEnded) {
					listener.detectionCycleEnded();
				}
			}
		};
	}

	/**
	 * Returns 1 if a motion was detected. How long this returns 1 after a motion
	 * was detected can be adjusted with one of the small potentiometers on the
	 * Motion Detector Bricklet, see :ref:`here
	 * &lt;motion_detector_bricklet_sensitivity_delay_block_time&gt;`.
	 * 
	 * There is also a blue LED on the Bricklet that is on as long as the Bricklet is
	 * in the "motion detected" state.
	 */
	public short getMotionDetected() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MOTION_DETECTED, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short motion = IPConnection.unsignedByte(bb.get());

		return motion;
	}

	/**
	 * Sets the status led configuration.
	 * 
	 * By default the status LED turns on if a motion is detected and off is no motion
	 * is detected.
	 * 
	 * You can also turn the LED permanently on/off.
	 * 
	 * .. versionadded:: 2.0.1$nbsp;(Plugin)
	 */
	public void setStatusLEDConfig(short config) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_STATUS_LED_CONFIG, this);

		bb.put((byte)config);

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletMotionDetector#setStatusLEDConfig(short)}.
	 * 
	 * .. versionadded:: 2.0.1$nbsp;(Plugin)
	 */
	public short getStatusLEDConfig() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_STATUS_LED_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short config = IPConnection.unsignedByte(bb.get());

		return config;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a MotionDetected listener.
	 */
	public void addMotionDetectedListener(MotionDetectedListener listener) {
		listenerMotionDetected.add(listener);
	}

	/**
	 * Removes a MotionDetected listener.
	 */
	public void removeMotionDetectedListener(MotionDetectedListener listener) {
		listenerMotionDetected.remove(listener);
	}

	/**
	 * Adds a DetectionCycleEnded listener.
	 */
	public void addDetectionCycleEndedListener(DetectionCycleEndedListener listener) {
		listenerDetectionCycleEnded.add(listener);
	}

	/**
	 * Removes a DetectionCycleEnded listener.
	 */
	public void removeDetectionCycleEndedListener(DetectionCycleEndedListener listener) {
		listenerDetectionCycleEnded.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletMotionDetector.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletMotionDetector.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletMotionDetectorConfig cfg = (BrickletMotionDetectorConfig) config.as(BrickletMotionDetectorConfig.class);
        this.addMotionDetectedListener(() -> {if(true) {triggerChannelFn.accept("MotionDetectorMotionDetected", transformMotionDetectorMotionDetectedCallback0(cfg));}});
		this.addDetectionCycleEndedListener(() -> {if(true) {triggerChannelFn.accept("MotionDetectorDetectionCycleEnded", transformMotionDetectorDetectionCycleEndedCallback0(cfg));}});
        
		{
		
		}
		{
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletMotionDetectorConfig cfg = (BrickletMotionDetectorConfig) config.as(BrickletMotionDetectorConfig.class);
        this.listenerMotionDetected.clear();
		this.listenerDetectionCycleEnded.clear();
        
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletMotionDetectorConfig cfg = (BrickletMotionDetectorConfig) config.as(BrickletMotionDetectorConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("MotionDetectorMotionDetected");
		result.add("MotionDetectorDetectionCycleEnded");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Motion Detector Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Passive infrared (PIR) motion sensor with 7m range").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("MotionDetectorMotionDetected", new ChannelTypeUID("system", "trigger")).withLabel("Motion Detected").withDescription("This channel is triggered after a motion was detected.").build(), new ChannelDefinitionBuilder("MotionDetectorDetectionCycleEnded", new ChannelTypeUID("system", "trigger")).withLabel("Detection Cycle Ended").withDescription("This channel is triggered when the detection cycle ended. A new motion can be detected again after approximately 2 seconds.").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:motiondetector":
                return new ConfigDescription(uri, Arrays.asList(), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletMotionDetectorConfig cfg = (BrickletMotionDetectorConfig) config.as(BrickletMotionDetectorConfig.class);
        switch(value) {
            case "MotionDetectorMotionDetected":
                   triggerChannelFn.accept(value, transformMotionDetectorMotionDetectedGetter0(this.getMotionDetected(), cfg));
                   return;
            case "MotionDetectorDetectionCycleEnded":
                   triggerChannelFn.accept(value, transformMotionDetectorDetectionCycleEndedGetter0(this.getMotionDetected(), cfg));
                   return;
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletMotionDetectorConfig cfg = (BrickletMotionDetectorConfig) config.as(BrickletMotionDetectorConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformMotionDetectorMotionDetectedCallback0(BrickletMotionDetectorConfig cfg) {
        return "";
    }
	    private String transformMotionDetectorDetectionCycleEndedCallback0(BrickletMotionDetectorConfig cfg) {
        return "";
    }
	    private String transformMotionDetectorMotionDetectedGetter0(short value, BrickletMotionDetectorConfig cfg) {
        return "";
    }
	    private String transformMotionDetectorDetectionCycleEndedGetter0(short value, BrickletMotionDetectorConfig cfg) {
        return "";
    }
}
